#include "defsetupW.h"

#define PTRSIZE 4
#define DATASTEP (REGSIZE)
#define TEMPSTEP 4*PTRSIZE

const bool ivst=InvertShift;
int length8=(length)*TEMPSTEP/2;/////////////at  the moment is length expected mod2
int length8P=length8+TEMPSTEP;
int alignwidth=DATASTEP*int((width+DATASTEP-1)/DATASTEP);
int negalignwidth=-alignwidth;

_declspec(align(16)) signed short rounder[8];
_declspec(align(16)) unsigned short limiter8bit[8];
_declspec(align(16)) unsigned char shifter[16];
_declspec(align(16)) unsigned char shufmask[16];
_declspec(align(16)) signed char multipliers[(MaxLen+2)/2*16/1];//length/twoframes per step*alignment/size of char
_declspec(align(16)) unsigned char* rowendptrs[(MaxLen+4)*2];// needs constant :-(

for (int i=0;i<length/2;++i)							//length/twoframes per step
	for (int j=0;j<16;j+=2)								//alignment/size of char
	{
		multipliers[i*16 + j]     = signed char (ScaledWeight[2*i]);
		multipliers[i*16 + j+1]   = signed char (ScaledWeight[2*i+1]);
	}
for (int j=0;j<8;++j)
	rounder[j] = signed short (ScaledBias);
for (int j=0;j<8;++j)
	limiter8bit[j] = (1<<(8+(InvertShift ? -ScaleW_SBPower:ScaleW_SBPower)))-1;
for (int i=0;i<16;++i)
	shifter[i]=0;
shifter[0]=ScaleW_SBPower;
for (int i=0;i<8;++i){
	shufmask[i]=2*i;
	shufmask[i+8]=2*i+1;
}
for (int i=0;i<(length+4)*2;++i)
	rowendptrs[i]=frameptrs[i]+alignwidth;
//rowendptrs[2]=shufmask;//so at the end of the cycle I can endup with pointers to shufmask and rounder in mask pointers
//rowendptrs[3]=(unsigned char*)rounder;

int y_cnt=s_height;

__asm
{
pushad

movdqa		xmm5, [shifter]
movdqa		xmm4, xmmword ptr [rounder]
mov		esi, [length8]

LABEL_VERTICAL:

	mov		edi, [negalignwidth]

LABEL_HORIZONTAL:

		movdqa		xmm6, xmm4
		movdqa		xmm7, xmm4

LABEL_TEMPORAL:
			mov		eax, [rowendptrs+esi]        //loading data here
			mov		ecx, [rowendptrs+esi+8]

			movdqa		xmm1, xmmword ptr [eax+edi]//clip n
			movdqa		xmm2, xmmword ptr [ecx+edi]//clip n+1
			movdqa		xmm3, [multipliers+esi-TEMPSTEP]     //multiplier          
						//time to do something
			movdqa		xmm0, xmm1
			punpcklbw   xmm0, xmm2    //clips 0...7
			punpckhbw   xmm1, xmm2    //clips 8...f

			pmaddubsw   xmm0, xmm3    
			pmaddubsw   xmm1, xmm3    
						//time to do something
			sub		esi, TEMPSTEP

			paddw       xmm6, xmm0
			paddw       xmm7, xmm1
			
			jnz LABEL_TEMPORAL

#ifdef LSB_OUT
		test [ivst],1     //is scaling shift right or left (inverse)
		mov		eax, [rowendptrs]
		mov		ebx, [rowendptrs+4]
		jnz LABEL_INV_SHIFT

		psraw		xmm6, xmm5			
		psraw		xmm7, xmm5			
		mov		esi, [length8]

		movdqa		xmm1, qword ptr [shufmask]
			
		pxor		xmm0, xmm0
		pmaxsw		xmm6, xmm0
		pmaxsw		xmm7, xmm0

		pshufb		xmm6, xmm1                
		pshufb		xmm7, xmm1                

		movdqa		xmm3, xmm6

		punpcklqdq	xmm3, xmm7
		punpckhqdq	xmm6, xmm7

		movdqa		xmmword ptr  [ebx+edi], xmm3
		movdqa		xmmword ptr  [eax+edi], xmm6

		add		edi, DATASTEP
		jnz LABEL_HORIZONTAL
		jmp LABEL_PITCHCYCLE

LABEL_INV_SHIFT:
		mov		esi, [length8]

		pxor		xmm0, xmm0
		pmaxsw		xmm6, xmm0
		pmaxsw		xmm7, xmm0
		movdqa		xmm2, xmm6
		movdqa		xmm3, xmm7

		psllw		xmm6, xmm5			
		psllw		xmm7, xmm5			

		movdqa		xmm0, xmm6
		movdqa		xmm1, xmm7

		psrlw		xmm0, xmm5			
		psrlw		xmm1, xmm5			

		pcmpgtw		xmm2, xmm0
		pcmpgtw		xmm3, xmm1

		por			xmm6, xmm2
		por			xmm7, xmm3

		movdqa		xmm1, qword ptr [shufmask]

		pshufb		xmm6, xmm1                
		pshufb		xmm7, xmm1                

		movdqa		xmm3, xmm6

		punpcklqdq	xmm3, xmm7
		punpckhqdq	xmm6, xmm7

		movdqa		xmmword ptr  [ebx+edi], xmm3
		movdqa		xmmword ptr  [eax+edi], xmm6

		add		edi, DATASTEP
		jnz LABEL_HORIZONTAL

#else
		test [ivst],1      //is scaling shift right or left (inverse)
		mov		eax, [rowendptrs]
		jnz LABEL_INV_SHIFT

		psraw		xmm6, xmm5			
		psraw		xmm7, xmm5			
		mov		esi, [length8]

		packuswb	xmm6, xmm7		
		movdqa		xmmword ptr  [eax+edi], xmm6

		add		edi, DATASTEP
		jnz LABEL_HORIZONTAL
		jmp LABEL_PITCHCYCLE

LABEL_INV_SHIFT:
		mov		esi, [length8]

		movdqa		xmm1, [limiter8bit]
		pxor		xmm0, xmm0

		pmaxsw		xmm6, xmm0
		pmaxsw		xmm7, xmm0

		movdqa		xmm2, xmm6
		movdqa		xmm3, xmm7
		pcmpgtw		xmm2, xmm1
		pcmpgtw		xmm3, xmm1

		movdqa		xmm0, qword ptr [shufmask]

		psllw		xmm6, xmm5			
		psllw		xmm7, xmm5			
		por			xmm6, xmm2
		por			xmm7, xmm3

		pshufb		xmm6, xmm0                
		pshufb		xmm7, xmm0                
		punpcklqdq	xmm6, xmm7

		movdqa		xmmword ptr  [eax+edi], xmm6

		add		edi, DATASTEP
		jnz LABEL_HORIZONTAL
#endif







LABEL_PITCHCYCLE:                           //next line, so here increasing pitch
		movdqa      xmm1, xmmword ptr [rowendptrs+esi]
		paddd		xmm1, xmmword ptr [pitches+esi]
		movdqa      xmmword ptr [rowendptrs+esi], xmm1
		sub		esi, TEMPSTEP
		jnz	LABEL_PITCHCYCLE
	movdqa      xmm1, xmmword ptr [rowendptrs]
	paddd		xmm1, xmmword ptr [pitches]
	movdqa      xmmword ptr [rowendptrs], xmm1

	dec		y_cnt
	mov		esi, [length8]
	jnz LABEL_VERTICAL

emms
popad
}

SuccesfullyDone=true;

#include "defresetW.h"