switch (lsb)
{
case 1://16bit in 8bit out
	{
		const long long roundedbias=ScaledBias;
		const int scalepower=ScaleW_CPower;
		for (int y = 0; y < s_height; ++y)
		{
			for (int x = 0; x < width; ++x)
			{
				long long sum0 = roundedbias;
				for (int i=0; i<length;++i) {
					sum0 += (sourceptrs[i*2+1][x]+(long long(sourceptrs[i*2][x])<<8))*ScaledWeight[i];
				}
				frameptrs[0][x]= unsigned int(max( min (sum0>>scalepower,maxbit-1),0));
			}
			for (int i=0;i<(length+2)*2;++i)
				frameptrs[i] += pitches[i];
		}
	}
	break;
case 2: //8bit in 16bit out
	{
		const int roundedbias=int(ScaledBias);
		const int scalepower=ScaleW_CPower;
		unsigned int a0;
		for (int y = 0; y < s_height; ++y)
		{
			for (int x = 0; x < width; ++x)
			{
				int sum0 = roundedbias;
				for (int i=0; i<length;++i) {
					sum0 += sourceptrs[i*2][x]*ScaledWeight[i];
				}
				a0 = unsigned int(max( min (sum0>>scalepower,maxbit-1),0));
				frameptrs[1][x] =(a0 % 256);
				frameptrs[0][x] =(a0 >> 8);
			}
			for (int i=0;i<(length+2)*2;++i)
				frameptrs[i] += pitches[i];
		}
	}
	break;
case 3: //16bit in 16bit out
	{
		const long long roundedbias=ScaledBias;
		const int scalepower=ScaleW_CPower;
		unsigned int a0;
		for (int y = 0; y < s_height; ++y)
		{
			for (int x = 0; x < width; ++x)
			{
				long long sum0 = roundedbias;
				for (int i=0; i<length;++i) {
					sum0 += (sourceptrs[i*2+1][x]+(long long(sourceptrs[i*2][x])<<8))*ScaledWeight[i];
				}
				a0 = unsigned int(max( min (sum0>>scalepower,maxbit-1),0));
				frameptrs[1][x] =(a0 % 256);
				frameptrs[0][x] =(a0 >> 8);
			}
			for (int i=0;i<(length+2)*2;++i)
				frameptrs[i] += pitches[i];
		}
	}
	break;
default: //8bit in 8bit out
	{
		const int roundedbias=int(ScaledBias);
		const int scalepower=ScaleW_CPower;
		for (int y = 0; y < s_height; ++y)
		{
			for (int x = 0; x < width; x+=8)
			{
				int sum0 = roundedbias;
				int sum1 = roundedbias;
				int sum2 = roundedbias;
				int sum3 = roundedbias;
				int sum4 = roundedbias;
				int sum5 = roundedbias;
				int sum6 = roundedbias;
				int sum7 = roundedbias;
				for (int i=0; i<length;++i) {
					sum0 += sourceptrs[i*2][x]*ScaledWeight[i];
					sum1 += sourceptrs[i*2][x+1]*ScaledWeight[i];
					sum2 += sourceptrs[i*2][x+2]*ScaledWeight[i];
					sum3 += sourceptrs[i*2][x+3]*ScaledWeight[i];
					sum4 += sourceptrs[i*2][x+4]*ScaledWeight[i];
					sum5 += sourceptrs[i*2][x+5]*ScaledWeight[i];
					sum6 += sourceptrs[i*2][x+6]*ScaledWeight[i];
					sum7 += sourceptrs[i*2][x+7]*ScaledWeight[i];
				}
				frameptrs[0][x] = unsigned int(max( min (sum0>>scalepower,255),0));
				frameptrs[0][x+1] = unsigned int(max( min (sum1>>scalepower,255),0));
				frameptrs[0][x+2] = unsigned int(max( min (sum2>>scalepower,255),0));
				frameptrs[0][x+3] = unsigned int(max( min (sum3>>scalepower,255),0));
				frameptrs[0][x+4] = unsigned int(max( min (sum4>>scalepower,255),0));
				frameptrs[0][x+5] = unsigned int(max( min (sum5>>scalepower,255),0));
				frameptrs[0][x+6] = unsigned int(max( min (sum6>>scalepower,255),0));
				frameptrs[0][x+7] = unsigned int(max( min (sum7>>scalepower,255),0));
			}
			for (int i=0;i<(length+2)*2;++i)
				frameptrs[i] += pitches[i];
		}
	}
}